// emptyTestAppDlg.cpp : implementation file
//

#include "stdafx.h"
#include "emptyTestApp.h"
#include "emptyTestAppDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEmptyTestAppDlg dialog

CEmptyTestAppDlg::CEmptyTestAppDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEmptyTestAppDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEmptyTestAppDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CEmptyTestAppDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEmptyTestAppDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEmptyTestAppDlg, CDialog)
	//{{AFX_MSG_MAP(CEmptyTestAppDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEmptyTestAppDlg message handlers

BOOL CEmptyTestAppDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CEmptyTestAppDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CEmptyTestAppDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CEmptyTestAppDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CEmptyTestAppDlg::OnOK() 
{
/* Sample code which parses simple expressions like 1+2*3-(4*5) */

	std::tstringstream strmInit(
		"[seperators]\n"
		"100:+\n"
		"101:-\n"
		"102:*\n"
		"103:/\n"
		"104:(\n"
		"105:)\n"
		"[rules]\n"
		"200:numbers\n"
		"[grammar]\n"
		"300:{.expr}=0:{!number}\n"
		"301:{.expr}=50:{.expr}{$+}{.expr}\n"
		"302:{.expr}=50:{.expr}{$-}{.expr}\n"
		"303:{.expr}=45:{.expr}{$*}{.expr}\n"
		"304:{.expr}=45:{.expr}{$/}{.expr}\n"
		"305:{.expr}=0:{$(}{.expr}{$)}\n");

	std::tstringstream	strmInput("2+3*4-(5+6)*7");
	cxTokenizerSTLInputStream< std::tstringstream,cxTokenizerInputStreamDefaultWithLineNumberImpl<crlf_lfonly> >
		istream(strmInput,false);

	cxtPackage pkg(strmInit);

	// flush the internal token stream
	pkg.vFlush();
	pkg.vSetStartFromBeginning();
	
	// attach the input stream to the tokenizer/analyzer
	pkg.vSetInputStream(&istream);
	pkg.vSetDelimeterIDs(NULL);
	
	// read until the next delimeter - no delimeters are set, i.e. read until the end of the input stream
	pkg.nReadUntilDelimeter();

	// check for the '.expr' rules defined above
	cxaTokenStream::const_iterator endpos;	
	cxaParseBranch *papbResult = NULL;
	cxaStatusCookie ascCondition;

	// test for all rules belonging to the same group of rules
	// with ID 300
	papbResult	=pkg.papbCheckForRule(300,&endpos,&ascCondition,false);

	if(papbResult==NULL)
		AfxMessageBox("Syntax error.");
	else
		{
		// could the complete token stream be parsed?
		// (for example, the expr '3+4++++++' can be parsed up
		// to '3+4', the rest is in error)
		if(endpos != pkg.patsGetTokenStream()->end())
			AfxMessageBox("Not all tokens could be analyzed.");
		else
			{
			// Take a look in the Debug log
			// For information on how to access the data, see
			// absd.hypermart.net. i hope i get the site ad-free
			// sometime soon :(
			papbResult->vDump();
			}

		delete papbResult;
		}

	// detach the input stream
	pkg.vSetInputStream(NULL);
}
