// grammarIDEDoc.h : interface of the CGrammarIDEDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_GRAMMARIDEDOC_H__E68DFF42_3FDE_4A31_A729_F47227A6F316__INCLUDED_)
#define AFX_GRAMMARIDEDOC_H__E68DFF42_3FDE_4A31_A729_F47227A6F316__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

struct docElement
	{
	bool		fSkip;
	CString		strLine;
	CString		strError;
	};

class CGrammarIDEDoc : public CDocument
{
protected: // create from serialization only
	CGrammarIDEDoc();
	DECLARE_DYNCREATE(CGrammarIDEDoc)

// Attributes
public:
	CArray<docElement,docElement&> m_aRules;
	cxtPackage					*m_pPkg;

// Operations
public:
	bool						TryReloadPackage(CString& strErrorText, CString& strErrorDesc);
	bool						ReloadPackage(CString& strErrors);
	bool						ReloadFromEditor(CRichEditCtrl* pCtrl, CString& strErrors);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGrammarIDEDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CGrammarIDEDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CGrammarIDEDoc)
	afx_msg void OnUpdateFileSave(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnViewEvaluation();
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GRAMMARIDEDOC_H__E68DFF42_3FDE_4A31_A729_F47227A6F316__INCLUDED_)
