/*********************************************************************
	Copyright (C) 2001 by

		Alexander Berthold, alexander-berthold@web.de.
		Hoegestr. 54
		79108 Freiburg i. Breisgau
		Germany

    -- This file is part of cxTokenizer --

    "cxTokenizer" is free software; you can redistribute it and/or 
	modify it under the terms of the GNU Lesser General Public 
	License as published by the Free Software Foundation; either 
	version 2 of the License, or any later version.

    "cxTokenizer" is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
	License along with "cxTokenizer"; if not, write to the Free 
	Software  Foundation, Inc., 59 Temple Place, Suite 330, 
	Boston, MA  02111-1307  USA

    ---------------------------------------------------------------
      If you find any bugs or if you make other corrections/
	  enhancements, i'd appreciate if you'd let me know about 
	  that. My email is
  
       alexander-berthold@web.de
  
      If you share this code, do not remove this text.
    ---------------------------------------------------------------

*********************************************************************/

// cxTokenizerCharTokenRule.cpp: implementation of the cxTokenizerCharTokenRule class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#include "cxTokenizerTokenRule.h"
#include "cxTokenizerCharTokenRule.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

cxTokenizerCharTokenRule::cxTokenizerCharTokenRule(int nIDValue, xttr_flags ttrf, LPCTSTR lpszToken, const std::tstring& strInitString)
    :	cxTokenizerTokenRule(nIDValue, ttrf,lpszToken,strInitString)
	    {
	    
	    }

    cxTokenizerCharTokenRule::~cxTokenizerCharTokenRule()
	    {
	    
	    }

//////////////////////////////////////////////////////////////////////
// cxTokenizerCharTokenRule operations
//////////////////////////////////////////////////////////////////////

    bool	cxTokenizerCharTokenRule::fDoesApply(
				const cxTokenizerContext* /*plcContext*/,
				TCHAR /*tcChar*/,
				bool *pfCompleted,
				int /* nStartPos*/, int /*nCurPos*/) const
	    {
	    (*pfCompleted)=true;
	    return true;
	    }

    void	cxTokenizerCharTokenRule::vApplied(
				cxTokenizerContext* /*plcContext*/,
				TCHAR /*tcChar*/,
				bool /*fCompleted*/,
				int /*nStartPos*/, int /*nCurPos*/) const
	    {
	    }

