#ifdef _DEBUG
bool	cxTokenizerMap::fCheckValid() const
	{
	if(!m_tmdFPRules.fCheckValid())
		return false;
	if(!m_tmdWIRules.fCheckValid())
		return false;

	return true;
	}

bool	cxTokenizerMap::fRunDiagnostics()
	{
	std::tstringstream	strm(
		_T("[seperators]\n")
		_T("-\n")
		_T("--\n")
		_T("[tokens]\n")
		_T("test\n")
		_T("[rules]\n")
		_T("strings\n")
		_T("numbers\n") );

	cxTokenizerMap					mapTest;
	cxTokenizerMapData				*pos;
	cxTokenizerMapData::iterator	it;

	mapTest.vLoadFromStream(strm);

	if(mapTest.m_vecRulesToDelete.size()!=5)
		return false;

	it			=mapTest.m_tmdWIRules.find('-');
	if(it==mapTest.m_tmdWIRules.end())
		return false;

	pos			=(*it).second;
	if(pos->m_pRule==NULL)
		return false;

	it			=pos->find('-');
	if(it==pos->end())
		return false;

	pos			=(*it).second;
	if(pos->m_pRule==NULL)
		return false;
	
	if(!mapTest.fCheckValid())
		return false;

	return true;
	}
#endif