#ifndef _LEXXER_FLAGS_DEFINED
#define _LEXXER_FLAGS_DEFINED

// LexxerTokenRules flags ...
enum	xttr_flags	
	{
	ttrf_character_rule=1,		// token consists only of ordered characters
	ttrf_computed_rule=0,		//   otherwise: token is being computed

	ttrf_intermediate=2,		// token is complete immediately after recognition
	ttrf_not_intermediate=0,	//   otherwise: token is complete only if the full token text
								//              (seperated by a 'within' token) is equal

	ttrf_within=4,				// token can appear within other tokens (like C++ '+')
	ttrf_seperate=0,			// token can appear only as a unit

	ttrf_dummy=8,				// token is just a dummy and will not be used
	};

// LexxerContext flags
enum	xtctx_flags	
	{
	tctx_exclusive=1
	};

#endif