// grammarIDEView.h : interface of the CGrammarIDEView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_GRAMMARIDEVIEW_H__7813B589_F243_4CA2_9BC3_F16B4BB7AAD6__INCLUDED_)
#define AFX_GRAMMARIDEVIEW_H__7813B589_F243_4CA2_9BC3_F16B4BB7AAD6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "propsItemGrammar.h"
#include "paneEditorWnd.h"

class CGrammarIDEView : public CView
{
protected: // create from serialization only
	CGrammarIDEView();
	DECLARE_DYNCREATE(CGrammarIDEView)

// Attributes
public:
	CGrammarIDEDoc*		GetDocument();
	CWnd*				m_pwndProps;
	CPaneEditorWnd*		m_pwndEditor;

// Operations
public:
	void				ClearPropertyWindow();
	void				ShowEditor(esection eSection = section_tokens);
	void				ShowPropertiesID(int nIDValue) {};
	void				ShowPropertiesAtm(int nAtmType) {};

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGrammarIDEView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CGrammarIDEView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CGrammarIDEView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	afx_msg void OnParseReparse();
	afx_msg void OnEditCut();
	afx_msg void OnEditCopy();
	afx_msg void OnEditPaste();
	afx_msg void OnEditUndo();
	//}}AFX_MSG
	afx_msg void OnStyleChanged(int nStyleType, LPSTYLESTRUCT lpStyleStruct);
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in grammarIDEView.cpp
inline CGrammarIDEDoc* CGrammarIDEView::GetDocument()
   { return (CGrammarIDEDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GRAMMARIDEVIEW_H__7813B589_F243_4CA2_9BC3_F16B4BB7AAD6__INCLUDED_)
